<?php
/*
Plugin Name: PG Subscribers Only
Plugin URI: http://plugingreat.com
Description: This plugin will hide parts of posts and pages from non-subscribers and instead invite them to sign up.
Version: 1.0.2
Author: Plugin' Great!
Author URI: http://plugingreat.com
*/

require_once('includes/lang_en.php');
require_once('includes/views.php');

function soAddPostNonSubscribers() {
  if( function_exists( 'add_meta_box' )) {
    add_meta_box( 'myplugin_sectionid', __( TXT_BOX_SUBSCRIBERSONLY, 'pg_member' ), 
                'soPostNonSubscribersCustomBox', 'post', 'advanced', 'high' );
    add_meta_box( 'myplugin_sectionid', __( TXT_BOX_SUBSCRIBERSONLY, 'myplugin_textdomain' ), 
                'soPostNonSubscribersCustomBox', 'page', 'advanced', 'high' );
   } else {
    add_action('dbx_post_advanced', 'soPostNonSubscribersOldCustomBox' );
    add_action('dbx_page_advanced', 'soPostNonSubscribersOldCustomBox' );
  }
}
function soPostNonSubscribersCustomBox() { //myplugin_inner_custom_box
	global $post;
	$post_id = $post->ID;
	
	$meta_value = get_post_meta($post_id, 'non_subscriber_post');
	echo '<input type="hidden" name="myplugin_noncename" id="myplugin_noncename" value="' . wp_create_nonce( plugin_basename(__FILE__) ) . '" />';
	$v = get_post_meta($post_id, 'segregatepost');
	displayFormBox($v);
}
function soPostNonSubscribersOldCustomBox() {

  echo '<div class="dbx-b-ox-wrapper">' . "\n";
  echo '<fieldset id="myplugin_fieldsetid" class="dbx-box">' . "\n";
  echo '<div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">' . 
        __( 'My Post Section Title', 'myplugin_textdomain' ) . "</h3></div>";   
   
  echo '<div class="dbx-c-ontent-wrapper"><div class="dbx-content">';

  soPostNonSubscribersCustomBox();

  // end wrapper

  echo "</div></div></fieldset></div>\n";
}
/* When the post is saved, saves our custom data */
function soUpdateCustomPostNonSubscribers( $post_id ) {

  if ( !wp_verify_nonce( $_POST['myplugin_noncename'], plugin_basename(__FILE__) )) {
    return $post_id;
  }

  if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
    return $post_id;

  if ( 'page' == $_POST['post_type'] ) {
    if ( !current_user_can( 'edit_page', $post_id ) )
      return $post_id;
  } else {
    if ( !current_user_can( 'edit_post', $post_id ) )
      return $post_id;
  }

  $ctr = 0;
  if(is_array($_POST['name']) && count($_POST['name'])>0){     
	  foreach($_POST['name'] as $k => $v){
		$mydata[$ctr]['name'] = $v; //$_POST['3']['name'];
		$mydata[$ctr]['public_value'] = $_POST['public_value'][$k]; //$_POST['3']['public_test'];
		$mydata[$ctr]['private_value'] = $_POST['private_value'][$k]; //$_POST['3']['private_test'];  
		$ctr++;
	  }
  }
  update_post_meta($post_id, "segregatepost", $mydata);

   return $mydata;
}
function soMemPostsReplaceNonSubscriberPost($content){
	global $current_user, $post;
	$post_id = $post->ID;
	get_currentuserinfo();
	$segregatepost = get_post_meta($post_id, 'segregatepost');
	$user = $current_user->user_login;
	if(is_array($segregatepost[0]) && count($segregatepost[0])>0){
	foreach($segregatepost[0] as $s){
		$pattern = '/[\[]SO[=]'.$s['name'].'[\]]/';	
		$pattern_post = '/[\[]SO[\-]LINK[\-]TO[\-]POST[\]]/';
		$pattern_url = '/[\[]SO[\-]BLOG[\-]URL[\]]/';
		if($user == '')
		{
			$content = preg_replace($pattern, '<div class="subscribers_only_public">'.$s['public_value'].'</div>', $content);
			$content = preg_replace($pattern_post, $post->guid, $content);
			$content = preg_replace($pattern_url, get_bloginfo('wpurl'), $content);
		}else
		{
			$content = preg_replace($pattern, $s['private_value'], $content);
		}
	}
	}
	return $content;
}
function soSubscribersOnly(){
$updated = false;
if(!empty($_POST)){
	$newvalue['restriction_msg'] = str_replace("\n", '', $_POST['restriction_msg']);
	update_option("subscriber_only_settings", $newvalue);
	$updated = true;
}
$so = get_option('subscriber_only_settings');
?>
	<div class="wrap">
		<h2><?php echo TXT_PAGE_SUBSCRIBERSONLY; ?></h2>
		<?php
			if($updated)
				echo '<div class="updated">' . "\n"
					. '<p>'
						. '<strong>'
						. __(TXT_MSG_OPTIONSAVED, 'subscribers_only')
						. '</strong>'
					. '</p>' . "\n"
					. '</div>' . "\n";		
		
			if(trim($so['restriction_msg']) == '') 
				$def_restriction_msg = '<p>This section is only available to <a href="/wp-login.php?redirect_to=[SO-LINK-TO-POST]">subscribers</a>.<br />
<a href="/wp-login.php?action=register&redirect_to=[SO-LINK-TO-POST]">Subscription</a> is <strong>FREE</strong>, and <i>takes just a moment</i>.</p>';
			else
				$def_restriction_msg = $so['restriction_msg'];		
		?>
		
		<form name="subscriber_only_settings" action="" method="post" enctype="multipart/form-data">
			<p><label for="restriction_msg"><?php echo TXT_LBL_RESRICTIONMSG; ?></label></p>
			<textarea name="restriction_msg" id="restriction_msg"><?php echo str_replace('\"', '"', $def_restriction_msg); ?></textarea>
			<p class="submit"><input type="submit" class="button-primary" value="Update"/>
		</form>
	</div>
<?php	
}
function soSubscribersOnlyLoadMenu(){
	add_menu_page(TXT_MENUTITLE_SUBSCRIBERSONLY, TXT_MENUTITLE_SUBSCRIBERSONLY, "administrator", "subscribers-only", "soSubscribersOnly");
/*	add_submenu_page("subscribers-only", TXT_MENU_NEWS, TXT_MENU_NEWS, "administrator", "subscribers-only-news", "subscribersOnlyNews"); */
}

function subscribersOnlyNews(){?>
	<div class="wrap" style="height:100%">
	<?php
		displaySubscribersOnlyNews(TXT_PAGE_NEWS);
	?>
	</div><?php
}

wp_enqueue_style('subscribers_only_style', get_bloginfo('wpurl') . '/wp-content/plugins/'.basename(dirname(__FILE__)).'/includes/style.css',null,null,false);
wp_enqueue_script('subscribers_only_script', get_bloginfo('wpurl') . '/wp-content/plugins/'.basename(dirname(__FILE__)).'/includes/scripts.js',null,null,false);	
add_filter('the_content', 'soMemPostsReplaceNonSubscriberPost', 1);
add_action('admin_menu', 'soAddPostNonSubscribers'); //myplugin_add_custom_box
add_action('save_post', 'soUpdateCustomPostNonSubscribers'); //myplugin_save_postdata
add_action('admin_menu', 'soSubscribersOnlyLoadMenu');
?>
